/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_HingeOp_h__
#define __operator_HingeOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator to rotate a surface out of another

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT HingeOp:
	public OperatorSurfaceCommon,
	public Initialize<HingeOp>
{
	public:

					HingeOp(void)											{}
virtual				~HingeOp(void)										{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

	private:
static	void		calcConversion(SpatialTransform& a_rTransform,
							const Real a_angle,const SpatialVector& a_rAxis,
							const SpatialVector& a_rPivot);
};

} /* namespace */

#endif /* __operator_HingeOp_h__ */

